-- config
local screen_interval = 3 -- minimum time between screens for one player
local view_screen_access = 1 -- minimum access needed to view info about screens
-- script
local players_lastscreen = {}

function onSay(cid, words, param, channel)
	local time_now = os.time()
	if getPlayerAccess(cid) >= view_screen_access and param ~= "" then
		local screen = db.getResult("SELECT `id`, `time`, `text` FROM `z_screens` WHERE `id` = " .. db.escapeString(param) .. ";")
		if(screen:getID() == -1) then
			text = ""
		else
			local screenId = screen:getDataString("id")
			local screenTime = screen:getDataInt("time")
			local screenText = screen:getDataString("text")
			screen:free()
			text = "Wynik z bazy dla ID " .. screenId .. ", data: " .. os.date("%H:%M:%S", screenTime) .. "\n" .. screenText
		end
	elseif players_lastscreen[getPlayerGUID(cid)] == nil or time_now > players_lastscreen[getPlayerGUID(cid)]+screen_interval then
		players_lastscreen[getPlayerGUID(cid)] = time_now
		local pos = getCreaturePosition(cid)
		local bots = getSpectators(pos, 7, 5, TRUE)
		local bot_list = "Author:\n" .. getCreatureName(cid) .. ",x=" .. pos.x .. ",y=" .. pos.y .. ",z=" .. pos.z .. "," .. getPlayerIp(cid) .. "," .. doConvertIntegerToIp(getPlayerIp(cid)) .. "\nCreatures:"
		for i = 1, #bots do
			bot = bots[i]
			if bot ~= cid then
				local bot_pos = getCreaturePosition(bot)
				bot_list = bot_list .. "\n" .. getCreatureName(bot) .. ",x=" .. bot_pos.x-pos.x .. ",y=" .. bot_pos.y-pos.y .. ",z=" .. bot_pos.z-pos.z
				if isPlayer(bot) == TRUE then
					bot_list = bot_list .. ", ip= " .. doConvertIntegerToIp(getPlayerIp(bot))
				end
				target = getCreatureTarget(bot)
				if(target ~= 0) then
					bot_list = bot_list .. ", target=" .. getCreatureName(target)
				end
			end
		end
		db.executeQuery("INSERT INTO `z_screens` (`player_id`, `time`, `text`) VALUES (" .. getPlayerGUID(cid) .. ", " .. time_now .. ", " .. db.escapeString(bot_list) .. ");")
		local screen_id = db.getResult("SELECT `id` FROM `z_screens` WHERE `time` = " .. db.escapeString(time_now) .. " AND `player_id` = " .. db.escapeString(getPlayerGUID(cid)) .. ";")
		if(screen_id:getID() == -1) then
			text = "Nie udalo sie zapisac screen w bazie."
		else
			--test
			text = "Screen zapisany w bazie. Twoj screen ma ID: " .. screen_id:getDataInt("id")
			screen_id:free()
		end
	else 
		text = "Jeden zapis ekranu mozna robic co " .. screen_interval .. " sekund."
	end
	local lines = string.explode(text, "\n")
	for i = 1, #lines do
		doPlayerSendTextMessage(cid, MESSAGE_STATUS_CONSOLE_BLUE, lines[i])
	end
	return true
end 
